inline void get_scale_factors
	(side_info_type *si,
	scalefac_type *scalefac,
	int gr,
	int ch,
	bit_stream_struc bitstream)
{
	int sfb, i, window;
	struct gr_info_type *gr_info = &(si->ch[ch].gr[gr]);
	bit_stream_struc *bs=&bitstream;

	if (gr_info->window_switching_flag && (gr_info->block_type == 2))
	{
      if (gr_info->mixed_block_flag)
      { // mixed blocks;
         for (sfb = 0; sfb < 8; sfb++)
            scalefac->ch[ch].l[sfb] = getbits(bs,slen[0][gr_info->scalefac_compress]);
         for (sfb = 3; sfb < 6; sfb++)
            for (window=0; window<3; window++)
               scalefac->ch[ch].s[window][sfb] = getbits(bs,slen[0][gr_info->scalefac_compress]);
         for (sfb = 6; sfb < 12; sfb++)
            for (window=0; window<3; window++)
               scalefac->ch[ch].s[window][sfb] = getbits(bs,slen[1][gr_info->scalefac_compress]);
         for (sfb=12,window=0; window<3; window++)
            scalefac->ch[ch].s[window][sfb] = 0;
      }
      else
      {  // short blocks;
         for (sfb=0; sfb < 6; sfb++)
            for (window=0; window<3; window++)
                scalefac->ch[ch].s[window][sfb] = getbits(bs,slen[0][gr_info->scalefac_compress]);
         for (sfb=6; sfb < 12; sfb++)
            for (window=0; window<3; window++)
                scalefac->ch[ch].s[window][sfb] = getbits(bs,slen[1][gr_info->scalefac_compress]);
         for (sfb=12,window=0; window<3; window++)
            scalefac->ch[ch].s[window][sfb] = 0;
      }
    }
    else
    {   // long blocks;
    	for (sfb=0; sfb < 11; sfb++)
 	        scalefac->ch[ch].l[sfb] = getbits(bs,slen[0][gr_info->scalefac_compress]);
    	for (sfb=11; sfb < 21; sfb++)
 	        scalefac->ch[ch].l[sfb] = getbits(bs,slen[1][gr_info->scalefac_compress]);
        scalefac->ch[ch].l[21] = 0;
    }
}

